#pragma once
#include "NoiseSlice.h"

enum mouse_action_state
{
	MOUSE_INACTIVE,
	MOUSE_PANNING,
	MOUSE_ZOOMING,
	MOUSE_CUTOFF
};

class ProgramManager
{
public:
	ProgramManager(void);

	//runs loop.
	int Run(int argc, char **argv);
	~ProgramManager(void);
private:
	static ProgramManager* m_Manager;

	
	mouse_action_state m_MouseState;
	int mousedown_x, mousedown_y;
	bool should_update_noise;
	int m_textureWidth, m_textureHeight;

	GLuint m_noiseTexture[1];

	void static mousebutton(int button, int state, int x, int y);
	void static mousemove(int x, int y);
	void static tick(int value);
	void static display(void);
	void static reshape(int w, int h);

	void static menu_NoiseControl(int value);

	void output(int x, int y, char *string);
	void selectFont(int newfont);
	void selectMessage(int msg);
	void selectColor(int color);
	void UpdateTexture();

	NoiseSlice m_noiseSlice;
};
