#pragma once
#include <simplexnoise1234.h>
#include <utils.h>
#include <WindowMapping.h>
//#include "NoiseControls.h"


class NoiseSlice
{
public:
	NoiseSlice();
	void InitializeNoiseBitmap(int width, int height);

	~NoiseSlice(void);

	void WriteNoiseBitmap();

	//physical bitmap
	GLubyte* m_bitmapBits;
	int m_bitmapHeight, m_bitmapWidth;

	//coordinates, zoom
	void SetCoordinates(float x, float y, float zoomX, float zoomY);
	void MoveCoordinates(int delta_x, int delta_y);
	void ChangeZoom(float zoom);
	void IncrementZoom(float deltazoom);
	void IncrementCuttoff(float deltacutoff);

	void ResetCoords();

	//other parameters
	void ChangeCutoff(float newCutoff);

private:
	void UpdateWindowMapper();
	float m_cutoff;
	WindowMapping m_windowMapping;
	POINTFLOAT m_coords;
	float m_zoomx;
	float m_zoomy;

};